/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so.registroasistencia.mysqlDAO;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import org.json.JSONArray;
import org.json.JSONObject;
import so.registroasistencia.dao.AsistenciaDAO;
import so.registroasistencia.utilities.GeneralVariables;
import so.registroasistencia.utilities.ResponseHelper;

/**
 *
 * @author Felipe Escala
 */
public class AsistenciaMysqlDAO implements AsistenciaDAO {

	@Override
	public JSONObject registrarAsistencia(JSONObject datos) throws Exception {
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		CallableStatement cst = null;
		ResultSet rSet = null;
		int rs;
		String sql;
		ResponseHelper response = new ResponseHelper();
		try {
			boolean check = validarAsistenciasDiarias();
			if (check) {
				con = MysqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
				con.setAutoCommit(false);
				sql = "SELECT IFNULL( "
					+ "	( "
					+ "	SELECT codestudiante "
					+ "	FROM estudiante "
					+ "	WHERE	dni = ? "
					+ "	), -1 "
					+ ")";
				pst = con.prepareStatement(sql);
				pst.setString(1, datos.getString("dniEstudiante"));
				rSet = pst.executeQuery();
				rSet.next();
				int codigoEstudiante = rSet.getInt(1);
				if (codigoEstudiante != -1) {
					sql = " SELECT a.codigo_aula, IF(a.estado_asistencia = 0, a.codigo_asistencia, -1)  "
						+ " FROM asistencias AS a "
						+ " WHERE a.codigo_estudiante = ? "
						+ " AND a.fecha_asistencia = DATE(NOW()) "
						+ " AND TIME(NOW())  "
						+ " BETWEEN TIMEDIFF(a.hora_ingreso, '01:00')  "
						+ " AND a.hora_salida ";
					pst = con.prepareStatement(sql);
					pst.setInt(1, codigoEstudiante);
					rSet = pst.executeQuery();
					while (rSet.next()) {
						JSONObject obj = new JSONObject();
						obj.put("codigoAula", rSet.getInt(1));
						obj.put("codigoAsistencia", rSet.getInt(2));
						lista.put(obj);
					}
					if (lista.length() > 1) {
						response.setStatus(false);
						response.setMessage(" Tiene un cruce en sus clases.\n "
							+ " Para registrar su asistencia, acerquese a la secretaria de su sede. ");
					} else if (lista.length() == 1) {
						int codigoAsistencia = lista.getJSONObject(0).getInt("codigoAsistencia");
						int codigoAula = lista.getJSONObject(0).getInt("codigoAula");
						if (codigoAsistencia != -1) {
							pst = con.prepareStatement("{call validarPension(?, ?, @rs)}");
							pst.setInt(1, codigoAula);
							pst.setInt(2, codigoEstudiante);
							rSet = pst.executeQuery();
							rSet.next();
							int estadoPago = rSet.getInt(1);
							if (estadoPago == 1) {
								pst = con.prepareStatement("{call registrarAsistencia(?)}");
								pst.setInt(1, codigoEstudiante);
								rs = pst.executeUpdate();
								if (rs == 1) {
									sql = " SELECT "
										+ "	CONCAT_WS(' ',e.nombres,e.paterno,e.materno), "
										+ "	CONCAT_WS(' ',n.nivel,IF(g.grado = 'NORMAL',NULL,g.grado),c.ciclo,t.turno) "
										+ "FROM "
										+ "	estudiante AS e "
										+ "INNER JOIN matricula AS m ON m.cod_estud_matri = e.codestudiante "
										+ "INNER JOIN aula AS a ON a.codAula = m.codAula "
										+ "INNER JOIN academia_grado AS g ON g.idgrado = a.codTipoGrado "
										+ "INNER JOIN academia_nivel AS n ON a.codNivel = n.idnivel "
										+ "INNER JOIN academia_ciclo AS c ON c.idciclo = a.codGrado "
										+ "INNER JOIN academia_turno AS t ON t.idturno = a.codTurno "
										+ "WHERE "
										+ "	e.codestudiante = ? "
										+ "AND a.codAula = ? ";
									pst = con.prepareStatement(sql);
									pst.setInt(1, codigoEstudiante);
									pst.setInt(2, codigoAula);
									rSet = pst.executeQuery();
									if (rSet.next()) {
										data.put("nombreEstudiante", rSet.getString(1));
										data.put("nombreCiclo", rSet.getString(2));
										response.setData(data);
										response.setStatus(true);
										response.setMessage("Asistencia registrada correctamente");
										con.commit();
									} else {
										response.setStatus(false);
										response.setMessage("Ocurrio un error al registrar la asistencia");
									}
								} else {
									response.setStatus(false);
									response.setMessage("Ocurrio un error al registrar la asistencia");
								}
							} else {
								sql = " SELECT "
									+ " IFNULL( "
									+ "		( "
									+ "		SELECT p.codigo_permiso "
									+ "		FROM permisos AS p "
									+ "		WHERE p.codigo_estudiante = ?"
									+ "			AND p.estado_registro = 1 "
									+ "		AND DATE(NOW()) "
									+ "		BETWEEN DATE(p.fecha_inicio_permiso) "
									+ "		AND DATE(p.fecha_fin_permiso) "
									+ "		), -1)";
								pst = con.prepareStatement(sql);
								pst.setInt(1, codigoEstudiante);
								rSet = pst.executeQuery();
								rSet.next();
								rs = rSet.getInt(1);
								if (rs == -1) {
									response.setStatus(false);
									response.setMessage(" No está al día en sus pensiones.");
								} else {
									pst = con.prepareStatement("{call registrarAsistencia(?)}");
									pst.setInt(1, codigoEstudiante);
									rs = pst.executeUpdate();
									if (rs == 1) {
										sql = " SELECT "
											+ "	CONCAT_WS(' ',e.nombres,e.paterno,e.materno), "
											+ "	CONCAT_WS(' ',n.nivel,IF(g.grado = 'NORMAL',NULL,g.grado),c.ciclo,t.turno) "
											+ "FROM "
											+ "	estudiante AS e "
											+ "INNER JOIN matricula AS m ON m.cod_estud_matri = e.codestudiante "
											+ "INNER JOIN aula AS a ON a.codAula = m.codAula "
											+ "INNER JOIN academia_grado AS g ON g.idgrado = a.codTipoGrado "
											+ "INNER JOIN academia_nivel AS n ON a.codNivel = n.idnivel "
											+ "INNER JOIN academia_ciclo AS c ON c.idciclo = a.codGrado "
											+ "INNER JOIN academia_turno AS t ON t.idturno = a.codTurno "
											+ "WHERE "
											+ "	e.codestudiante = ? "
											+ "AND a.codAula = ? ";
										pst = con.prepareStatement(sql);
										pst.setInt(1, codigoEstudiante);
										pst.setInt(2, codigoAula);
										rSet = pst.executeQuery();
										if (rSet.next()) {
											data.put("nombreEstudiante", rSet.getString(1));
											data.put("nombreCiclo", rSet.getString(2));
											response.setData(data);
											response.setStatus(true);
											response.setMessage("Asistencia registrada correctamente");
											con.commit();
										} else {
											response.setStatus(false);
											response.setMessage("Ocurrio un error al registrar la asistencia");
										}
									} else {
										response.setStatus(false);
										response.setMessage("Ocurrio un error al registrar la asistencia");
									}
								}
							}
						} else {
							sql = " SELECT "
								+ "	CONCAT_WS(' ',e.nombres,e.paterno,e.materno), "
								+ "	CONCAT_WS(' ',n.nivel,IF(g.grado = 'NORMAL',NULL,g.grado),c.ciclo,t.turno) "
								+ "FROM "
								+ "	estudiante AS e "
								+ "INNER JOIN matricula AS m ON m.cod_estud_matri = e.codestudiante "
								+ "INNER JOIN aula AS a ON a.codAula = m.codAula "
								+ "INNER JOIN academia_grado AS g ON g.idgrado = a.codTipoGrado "
								+ "INNER JOIN academia_nivel AS n ON a.codNivel = n.idnivel "
								+ "INNER JOIN academia_ciclo AS c ON c.idciclo = a.codGrado "
								+ "INNER JOIN academia_turno AS t ON t.idturno = a.codTurno "
								+ "WHERE "
								+ "	e.codestudiante = ? "
								+ "AND a.codAula = ? ";
							pst = con.prepareStatement(sql);
							pst.setInt(1, codigoEstudiante);
							pst.setInt(2, codigoAula);
							rSet = pst.executeQuery();
							if (rSet.next()) {
								data.put("nombreEstudiante", rSet.getString(1));
									data.put("nombreCiclo", rSet.getString(2));
								response.setData(data);
								response.setStatus(false);
								response.setAditional(true);
								response.setMessage("Su asistencia ya ha sido registrada");
							} else {
								response.setStatus(false);
								response.setMessage("Ocurrio un error al registrar la asistencia");
							}
						}
					} else {
						sql = "	SELECT "
							+ "		COUNT(*) "
							+ "	FROM "
							+ "		estudiante AS e "
							+ "	INNER JOIN matricula AS m ON m.cod_estud_matri = e.codestudiante "
							+ "	INNER JOIN aula AS a ON a.codAula = m.codAula "
							+ "	AND DATE(NOW()) BETWEEN a.fechaInicio "
							+ "	AND a.fechaTermino "
							+ "	AND a.codSede IN (49, 29, 20, 18) "
							+ "	WHERE e.codestudiante = ? ";
						pst = con.prepareStatement(sql);
						pst.setInt(1, codigoEstudiante);
						rSet = pst.executeQuery();
						rSet.next();
						rs = rSet.getInt(1);
						if (rs >= 1) {
							sql = " SELECT COUNT(*)  "
								+ " FROM asistencias AS a "
								+ " WHERE a.codigo_estudiante = ? ";
							pst = con.prepareStatement(sql);
							pst.setInt(1, codigoEstudiante);
							rSet = pst.executeQuery();
							rSet.next();
							rs = rSet.getInt(1);
							if (rs >= 1) {
								response.setStatus(false);
								response.setMessage("Debe marcar asistencia hasta 1 hora antes de su clase");
							} else {
								response.setStatus(false);
								response.setMessage("No tiene clases el día de hoy");
							}
						} else {
							response.setStatus(false);
							response.setMessage("No está matriculado en ningún ciclo vigente");
						}
					}
				} else {
					response.setStatus(false);
					response.setMessage("No está matriculado en ningún ciclo vigente");
				}
			} else {
				response.setStatus(false);
				response.setMessage("No hay clases hoy");
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	private boolean validarAsistenciasDiarias() {
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		boolean result = false;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = MysqlDAOFactory.obtenerConexion(GeneralVariables.nameDB);
			sql = " select count(*) from asistencias where fecha_asistencia =  DATE(NOW()) ";
			pst = con.prepareStatement(sql);
			rSet = pst.executeQuery();
			if (rSet.next()) {
				result = rSet.getInt(1) >= 1;
			}
			if (!result) {
				pst = con.prepareCall("{call generarAsistencias()}");
				rs = pst.executeUpdate();
				result = rs >= 1;
			}
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		return result;
	}

}
