   /* global loader, swal */

   const helpers = {
      alertSuccess(message) {
         swal('REGISTRO EXITOSO', message, {
            timer: 1200,
            icon: 'success',
            button: false
         })
                 .then(data => {
                    $('#dniUsuario').val('')
                    $('#dniUsuario').focus()
                 })
      },
      alertError(message) {
         swal('¡ADVERTENCIA!', message, {
            timer: 1200,
            icon: 'warning',
            button: false
         })
                 .then(data => {
                    $('#dniUsuario').val('')
                    $('#dniUsuario').focus()
                 })
      }
   }
   const httpRequest = {
      registrarAsistencia(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: "../AsistenciaServlet",
               dataType: "json",
               data: {
                  json: JSON.stringify(json)
               },
               beforeSend: function (xhr) {
                  $('#aux').focus()
                  loader.iniciarLoader()
               },
               success: function (data, textStatus, jqXHR) {
                  loader.terminarLoader()
                  resolve(data)
               }, error: function (jqXHR, textStatus, errorThrown) {
                  loader.terminarLoader()
                  reject('Error en la petición')
               }
            })
         })
      }
   }

   const DOMEvents = {
      init() {
         this.registrarAsistencia()
         this.keepFocus()
      },
      registrarAsistencia() {
         $('#dniUsuario').bind('keypress', function (e) {
            if (e.charCode === 13 || e.keyCode === 13) {
               let dni = ($('#dniUsuario').val()).trim()
               let json = {
                  'dniEstudiante': dni
               }
               if (dni.length >= 8) {
                  httpRequest.registrarAsistencia(json)
                          .then(data => {
                             let lista = data.data
                             if (data.status) {
                                $('#dataUser').text(lista.nombreEstudiante)
                                $('#dataCiclo').text(lista.nombreCiclo)
                                $('#successMessage').text(data.message)
                                $('#dataUserSuccess').fadeIn()
                                setTimeout(() => {
                                   $('#dataUserSuccess').fadeOut()
                                }, 1700)
                                $('#dniUsuario').val('')
                                $('#dniUsuario').focus()
                             } else {
                                if ((data.message).includes('--->')) {
                                   $('#errorMessage').text('Ha ocurrido un error inesperado. \n Solicite ayuda a la secretaria')
                                   $('#dataUserError').fadeIn()
                                   setTimeout(() => {
                                      $('#dataUserError').fadeOut()
                                   }, 1700)
                                   $('#dniUsuario').val('')
                                   $('#dniUsuario').focus()
                                   console.log(data.message);
                                } else {
                                   if (data.aditional) {
                                      $('#dataUser').text(lista.nombreEstudiante)
                                      $('#dataCiclo').text(lista.nombreCiclo)
                                      $('#successMessage').text(data.message)
                                      $('#dataUserSuccess').fadeIn()
                                      setTimeout(() => {
                                         $('#dataUserSuccess').fadeOut()
                                      }, 1700)
                                      $('#dniUsuario').val('')
                                      $('#dniUsuario').focus()
                                   } else {
                                      $('#errorMessage').text(data.message)
                                      $('#dataUserError').fadeIn()
                                      setTimeout(() => {
                                         $('#dataUserError').fadeOut()
                                      }, 1500)
                                      $('#dniUsuario').val('')
                                      $('#dniUsuario').focus()
                                   }
                                }
                             }
                          })
                          .catch(err => {
                             console.log(err);
                          })
               } else {
                  helpers.alertError('Ingrese un DNI válido')
               }
            }
         });
      },
      keepFocus() {
         $('#dniUsuario').on('blur', () => {
            $('#dniUsuario').focus();
         });
      }
   }

   const initRequest = {
   }

   const initComponents = {
      init() {
         this.initClock()
         this.initValidate()
      },
      initClock() {
         var digitalClock = new dyClock(".dyclock-digital", {
            clock: "digital",
            format: "HH:mm:ss",
            digitalStyle: {
               backgroundColor: "transparent",
               fontColor: "white",
               fontSize: '8em',
               fontFamily: 'BalooDaRegular',
               textShadow: '2px 0 0 #000, -2px 0 0 #000, 0 2px 0 #000, 0 -2px 0 #000, 1px 1px #000, -1px -1px 0 #000, 1px -1px 0 #000, -1px 1px 0 #000'
            }
         });
         digitalClock.start();
      },
      initValidate() {
         new Input({el: '#dniUsuario', param: 'numbers'}).validate()
      }
   }

   init = () => {
      DOMEvents.init()
      initComponents.init()
   }

   init()